#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=FTPTest.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Res_Description=FTP Test By Ahbadiane
#AutoIt3Wrapper_Res_Fileversion=1.0.0.0
#AutoIt3Wrapper_Res_LegalCopyright=By Ahbadiane
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ---------------------------------------------------------------------------

	FTPTEst - Test FTP
	Script AutoIt Version 3.3.6.1

	Auteur : Ahbadiane
	Janvier 2011

#ce ---------------------------------------------------------------------------

#Region - Dclaration
#include <FTPEx.au3>
#include <GuiEdit.au3>
#include <ScrollBarConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <String.au3>
#include <Timers.au3>
#include <Misc.au3>


AutoItSetOption("MustDeclareVars", 1)

Global $scTitreAppli = "FTP Test v1.0 - By Ahbadiane"
Global $scCryptCle = "Ahbadiane"
Global $scFicIni = @ScriptDir & "\" & StringLeft(@ScriptName, StringLen(@ScriptName) - 4) & ".ini"
Global $scLibelleTaille = "Taille trait : "
Global $sAdresseServeur, $sNomUtilisateur, $sMotPasse
Global $hFTP, $IdFTP, $hCallBack
Global $iTailleProgression
Global $idMsg, $sTemp, $hEditTrace

#Region ### START Koda GUI section ### Form=D:\MesDocs\Suivi\AutoIt\_Version en cours\FTPTest\FTPTest.kxf
Global $FormFTPTest = GUICreate("~Titre~", 797, 631, -1, -1, BitOR($WS_CAPTION,$WS_POPUP,$WS_BORDER,$WS_CLIPSIBLINGS), BitOR($WS_EX_ACCEPTFILES,$WS_EX_WINDOWEDGE))
Global $Label1 = GUICtrlCreateLabel("Adresse serveur", 10, 13, 80, 17)
Global $InputServeur = GUICtrlCreateInput("", 163, 11, 529, 21)
Global $Label2 = GUICtrlCreateLabel("Nom utilisateur", 10, 39, 73, 17)
Global $InputUtilisateur = GUICtrlCreateInput("", 163, 37, 529, 21)
Global $Label3 = GUICtrlCreateLabel("Mot de passe", 10, 65, 68, 17)
Global $InputMotPasseVisible = GUICtrlCreateInput("", 163, 63, 529, 21)
GUICtrlSetState(-1, $GUI_HIDE)
Global $InputMotPasseMasque = GUICtrlCreateInput("", 163, 63, 529, 21, BitOR($ES_PASSWORD,$ES_AUTOHSCROLL))
Global $ButtonMotPasse = GUICtrlCreateButton("Afficher", 698, 62, 90, 22, $WS_GROUP)
Global $ButtonConnexion = GUICtrlCreateButton("Tester la connexion et la dconnexion", 10, 89, 778, 22, $WS_GROUP)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label4 = GUICtrlCreateLabel("Nom et dossier du fichier local", 10, 122, 145, 17)
Global $InputFichierLocal = GUICtrlCreateInput("", 163, 120, 529, 21)
Global $ButtonRechercher = GUICtrlCreateButton("Rechercher", 698, 119, 90, 22, $WS_GROUP)
Global $Label5 = GUICtrlCreateLabel("Nom et dossier du fichier distant", 10, 148, 154, 17)
Global $InputFichierServeur = GUICtrlCreateInput("", 163, 146, 529, 21)
Global $ButtonSupprimerFichierDistant = GUICtrlCreateButton("Supprimer fichier", 698, 145, 90, 22, $WS_GROUP)
Global $ButtonEnvoyer1 = GUICtrlCreateButton("Envoyer le fichier local vers le serveur (_FTP_Fileput)", 10, 176, 379, 22, $WS_GROUP)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $ButtonRapatrier1 = GUICtrlCreateButton("Rapatrier le fichier distant en local (_FTP_FileGet)", 409, 176, 379, 22, $WS_GROUP)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $ButtonEnvoyer2 = GUICtrlCreateButton("Envoyer le fichier local vers le serveur (_FTP_ProgressUpload)", 10, 201, 379, 22, $WS_GROUP)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $ButtonRapatrier2 = GUICtrlCreateButton("Rapatrier le fichier distant en local (_FTP_ProgressDownload)", 409, 201, 379, 22, $WS_GROUP)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label6 = GUICtrlCreateLabel("Dossier distant", 10, 234, 73, 17)
Global $InputDossierDistant = GUICtrlCreateInput("", 163, 232, 529, 21)
Global $ButtonCreerDossierDistant = GUICtrlCreateButton("Crer le dossier distant", 10, 264, 250, 22, $WS_GROUP)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $ButtonSupprimerDossierDistant = GUICtrlCreateButton("Supprimer le dossier distant", 275, 264, 250, 22, $WS_GROUP)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $ButtonListeFichiersDistant = GUICtrlCreateButton("Liste des fichiers et des dossiers distants", 538, 264, 250, 22, $WS_GROUP)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $EditTrace = GUICtrlCreateEdit("", 10, 295, 682, 329)
GUICtrlSetData(-1, "")
Global $ButtonEffacer = GUICtrlCreateButton("Effacer traces", 698, 295, 90, 25, $WS_GROUP)
Global $ButtonQuitter = GUICtrlCreateButton("Quitter l'utilitaire", 698, 599, 90, 25, $WS_GROUP)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

WinSetTitle("~Titre~", "", $scTitreAppli)
$hEditTrace = ControlGetHandle("FTP Test v1.0 - By Ahbadiane", "", $EditTrace)
LireFicIni()
WinSetOnTop($scTitreAppli, "", 1)

While 1
	$idMsg = GUIGetMsg()
	Switch $idMsg
		Case $ButtonQuitter
			ExitLoop
		Case $ButtonConnexion
			If Not SaisieValide(1) Then ContinueLoop
			EcrireFicIni()
			If Not Connexion() Then ContinueLoop
			Pause(1000)
			DeConnexion()
			MessageFin()
		Case $ButtonSupprimerFichierDistant
			If Not SaisieValide(7) Then ContinueLoop
			EcrireFicIni()
			If Not Connexion() Then ContinueLoop
			If Not SupprimerFichierDistant() Then ContinueLoop
			DeConnexion()
			MessageFin()
		Case $ButtonEnvoyer1, $ButtonEnvoyer2
			If Not SaisieValide(2) Then ContinueLoop
			EcrireFicIni()
			If Not Connexion(True, 1) Then ContinueLoop
			If $idMsg = $ButtonEnvoyer1 Then
				If Not Upload1() Then ContinueLoop
			Else
				If Not Upload2() Then ContinueLoop
			EndIf
			DeConnexion()
			MessageFin()
		Case $ButtonRapatrier1, $ButtonRapatrier2
			If Not SaisieValide(3) Then ContinueLoop
			EcrireFicIni()
			If Not Connexion(True, 2) Then ContinueLoop
			If $idMsg = $ButtonRapatrier1 Then
				If Not Download1() Then ContinueLoop
			Else
				If Not Download2() Then ContinueLoop
			EndIf
			DeConnexion()
			MessageFin()
		Case $ButtonCreerDossierDistant
			If Not SaisieValide(4) Then ContinueLoop
			EcrireFicIni()
			If Not Connexion() Then ContinueLoop
			If Not CreerDossierDistant() Then ContinueLoop
			DeConnexion()
			MessageFin()
		Case $ButtonSupprimerDossierDistant
			If Not SaisieValide(5) Then ContinueLoop
			EcrireFicIni()
			If Not Connexion() Then ContinueLoop
			If Not SupprimerDossierDistant() Then ContinueLoop
			DeConnexion()
			MessageFin()
		Case $ButtonListeFichiersDistant
			If Not SaisieValide(6) Then ContinueLoop
			EcrireFicIni()
			If Not Connexion() Then ContinueLoop
			If Not ListeFichiersDossierDistant() Then ContinueLoop
			DeConnexion()
			MessageFin()
		Case $ButtonMotPasse
			SynchroMotPasse()
			If GUICtrlRead($ButtonMotPasse) = "Masquer" Then
				GUICtrlSetState($InputMotPasseMasque, $GUI_SHOW)
				GUICtrlSetState($InputMotPasseVisible, $GUI_HIDE)
				GUICtrlSetData($ButtonMotPasse, "Afficher")
			Else
				GUICtrlSetState($InputMotPasseVisible, $GUI_SHOW)
				GUICtrlSetState($InputMotPasseMasque, $GUI_HIDE)
				GUICtrlSetData($ButtonMotPasse, "Masquer")
			EndIf
		Case $ButtonEffacer
			GUICtrlSetData($EditTrace, "")
		Case $ButtonRechercher
			$sTemp = FileOpenDialog("Rechercher du fichier local", DossierParDefaut(GUICtrlRead($InputFichierLocal), @ScriptDir), "Tous les fichiers (*.*)", 3)
			If @error <> 1 Then GUICtrlSetData($InputFichierLocal, $sTemp)
	EndSwitch
WEnd

Exit


;==================================================================

; $iTypeControleFicDistant : 1=Si le fichier distant existe, demander une confirmation pour l'craser
;							 2=Si le fichier dsitant n'existe pas, message d'erreur + arrt

Func Connexion($bCallBack = False, $iTypeControleFicDistant = 0)
	; _FTP_Open
	$hFTP = _FTP_Open("MonConnexion")
	If $hFTP <> 0 Then
		Message("_FTP_Open : OK")
	Else
		Message("_FTP_Open : Erreur - @error=" & @error, True)
		Return False
	EndIf
	; _FTP_SetStatusCallback
	If $bCallBack Then
		$hCallBack = _FTP_SetStatusCallback($hFTP, 'FTPCallBack1')
		If $hCallBack <> 0 Then
			Message("_FTP_SetStatusCallback : OK")
		Else
			Message("_FTP_SetStatusCallback : Erreur - @error=" & @error, True)
			Return False
		EndIf
	EndIf
	; _FTP_Connect
	$IdFTP = _FTP_Connect($hFTP, GUICtrlRead($InputServeur), GUICtrlRead($InputUtilisateur), GUICtrlRead($InputMotPasseMasque))
	If $IdFTP <> 0 Then
		Message("_FTP_Connect : OK")
	Else
		Message("_FTP_Connect : Erreur - @error=" & @error, True)
		Return False
	EndIf
	;
	If $iTypeControleFicDistant = 1 Then
		Message("Test si le fichier distant existe")
		_FTP_FileGetSize($IdFTP, GUICtrlRead($InputFichierServeur))
		If @error = 0 Then
			If MsgBox(4388, "Confirmation", "Le fichier distant existe dj." & @CRLF & "Voulez-vous le remplacer ?", 0, $FormFTPTest) = 7 Then
				DeConnexion()
				Message("Arrt du traitement par l'utilisateur", True)
				Return False
			EndIf
		EndIf
	EndIf
	;
	If $iTypeControleFicDistant = 2 Then
		Message("Test si le fichier distant existe")
		_FTP_FileGetSize($IdFTP, GUICtrlRead($InputFichierServeur))
		If @error <> 0 Then
			Message("Le fichier distant " & GUICtrlRead($InputFichierServeur) & " n'existe pas - Arrt du traitement")
			DeConnexion()
			MessageFin()
			Return False
		EndIf
	EndIf
	;
	Return True
EndFunc


Func Upload1()
	Local $iTempsInit = _Timer_Init()
	$iTailleProgression = 0
	Message($scLibelleTaille) ; permet d'initier la liste "Taille trait : "
	If _FTP_FilePut($IdFTP, GUICtrlRead($InputFichierLocal), GUICtrlRead($InputFichierServeur), 0, $hCallBack) = 1 Then
		Message("_FTP_FilePut : OK")
		Message("Temps de transfert = " & Round(_Timer_Diff($iTempsInit)/1000, 1) & " sec.")
	Else
		Message("_FTP_FilePut : Erreur - @error=" & @error, True)
		Return False
	EndIf
	Return True
EndFunc


Func Upload2()
	Local $iTempsInit = _Timer_Init()
	Message("**** Touche ECHAP pour stopper le traitement ****")
	Message($scLibelleTaille) ; permet d'initier la liste "Taille trait : "
	_FTP_ProgressUpload($IdFTP, GUICtrlRead($InputFichierLocal), GUICtrlRead($InputFichierServeur), "FTPCallBack2")
	Switch @error
		Case 0
			Message("_FTP_ProgressUpload : OK")
			Message("Temps de transfert = " & Round(_Timer_Diff($iTempsInit)/1000, 1) & " sec.")
			Message("Taille du fichier distant : " & _FTP_FileGetSize($IdFTP, GUICtrlRead($InputFichierServeur)) & " Octets")
		Case -6
			Message("_FTP_ProgressUpload arrt par l'utilisateur")
			Message("Temps de transfert = " & Round(_Timer_Diff($iTempsInit)/1000, 1) & " sec.")
		Case Else
			Message("_FTP_ProgressUpload : Erreur - @error=" & @error, True)
			Return False
	EndSwitch
	Return True
EndFunc


Func Download1()
	Local $iTempsInit = _Timer_Init()
	$iTailleProgression = 0
	Message($scLibelleTaille) ; permet d'initier la liste "Taille trait : "
	If _FTP_FileGet($IdFTP, GUICtrlRead($InputFichierServeur), GUICtrlRead($InputFichierLocal), False, 0, 0,$hCallBack) = 1 Then
		Message("_FTP_FileGet : OK")
		Message("Temps de transfert = " & Round(_Timer_Diff($iTempsInit)/1000, 1) & " sec.")
	Else
		Message("_FTP_FileGet : Erreur - @error=" & @error, True)
		Return False
	EndIf
	Return True
EndFunc


Func Download2()
	Local $iTempsInit = _Timer_Init()
	Message("**** Touche ECHAP pour stopper le traitement ****")
	Message($scLibelleTaille) ; permet d'initier la liste "Taille trait : "
	_FTP_ProgressDownload($IdFTP, GUICtrlRead($InputFichierLocal), GUICtrlRead($InputFichierServeur), "FTPCallBack2")
	Switch @error
		Case 0
			Message("_FTP_ProgressDownload : OK")
			Message("Temps de transfert = " & Round(_Timer_Diff($iTempsInit)/1000, 1) & " sec.")
			Message("Taille du fichier local : " & FileGetSize(GUICtrlRead($InputFichierLocal)) & " Octets")
		Case -6
			Message("_FTP_ProgressDownload arrt par l'utilisateur")
			Message("Temps de transfert = " & Round(_Timer_Diff($iTempsInit)/1000, 1) & " sec.")
		Case Else
			Message("_FTP_ProgressDownload : Erreur - @error=" & @error, True)
			Return False
	EndSwitch
	Return True
EndFunc


Func CreerDossierDistant()
	If _FTP_DirCreate($IdFTP, GUICtrlRead($InputDossierDistant))= 1 Then
		Message("_FTP_DirCreate : OK")
	Else
		Message("_FTP_DirCreate : Erreur - @error=" & @error, True)
		Return False
	EndIf
	Return True
EndFunc


Func SupprimerFichierDistant()
	If _FTP_FileDelete($IdFTP, GUICtrlRead($InputFichierServeur))= 1 Then
		Message("_FTP_FileDelete : OK")
	Else
		Message("_FTP_FileDelete : Erreur - @error=" & @error, True)
		Return False
	EndIf
	Return True
EndFunc

Func SupprimerDossierDistant()
	If _FTP_DirDelete($IdFTP, GUICtrlRead($InputDossierDistant))= 1 Then
		Message("_FTP_DirDelete : OK")
	Else
		Message("_FTP_DirDelete : Erreur - @error=" & @error, True)
		Return False
	EndIf
	Return True
EndFunc


Func ListeFichiersDossierDistant()
	Local $hNext, $aInfo, $iNbfic
	$aInfo = _FTP_FindFileFirst($IdFTP, GUICtrlRead($InputDossierDistant), $hNext)
	If @error <> 0 Then
		Message("_FTP_FindFileFirst : Erreur - Pas de fichier ou dossier inexistant")
	Else
		Message("_FTP_FindFileFirst : OK")
		While 1
			$iNbfic += 1
			If BitAND($aInfo[1], 0x00000010) Then
				Message("Dossier "& $iNbfic & " = " & $aInfo[10] & "      (Attribut=" & $aInfo[1]&  ")")
			Else
				Message("Fichier  "& $iNbfic & " = " & $aInfo[10] & "      (Attribut=" & $aInfo[1]&  ")")
			EndIf
			$aInfo = _FTP_FindFileNext($hNext)
			If @error <> 0 Then ExitLoop
		WEnd
		If _FTP_FindFileClose($hNext)= 1 Then
			Message("_FTP_FindFileClose : OK")
		Else
			Message("_FTP_FindFileClose : Erreur - @error=" & @error, True)
			Return False
		EndIf
	EndIf
	Return True
EndFunc


Func DeConnexion()
	If _FTP_Close($hFTP) = 1 Then
		Message("_FTP_Close : OK")
	Else
		Message("_FTP_Close : Erreur - @error=" & @error, True)
		Return
	EndIf
EndFunc


Func FTPCallBack1($hInternet, $dwContent, $dwInternetStatus, $lpvStatusInformation, $dwStatusInformationLength)
    If $dwInternetStatus = $INTERNET_STATUS_REQUEST_SENT  Or $dwInternetStatus = $INTERNET_STATUS_RESPONSE_RECEIVED Then
        Local $Size, $iBytesRead
        $Size = DllStructCreate('dword')
        _WinAPI_ReadProcessMemory(_WinAPI_GetCurrentProcess(), $lpvStatusInformation, DllStructGetPtr($Size), $dwStatusInformationLength, $iBytesRead)
		$iTailleProgression += DllStructGetData($Size, 1)
		Message($scLibelleTaille & $iTailleProgression & " Octets", False, True)
    EndIf
EndFunc


Func FTPCallBack2($iPourcent)
	Message($scLibelleTaille & $iPourcent & "%", False, True)
	If _IsPressed("1B") Then Return 0
	Return 1
EndFunc


Func Pause($iMilliSecondes)
	Message("Pause de " & Round($iMilliSecondes/1000, 1) & " sec.")
	Sleep($iMilliSecondes)
EndFunc


Func SaisieValide($iChoix)
	; Tous les choix
	If GUICtrlRead($InputServeur) = "" Then
		MsgBox(4096, "Erreur", "L'adresse serveur (ou hte) doit tre renseigne", 0, $FormFTPTest)
		Return False
	EndIf
	If ($iChoix = 2) Or ($iChoix = 3) Then
		If GUICtrlRead($InputFichierLocal) = "" Then
			MsgBox(4096, "Erreur", "Le fichier local doit tre renseign", 0, $FormFTPTest)
			Return False
		EndIf
	EndIf
	If $iChoix = 2 Then
		If Not FileExists(GUICtrlRead($InputFichierLocal)) Then
			MsgBox(4096, "Erreur", "Le fichier local renseign n'existe pas", 0, $FormFTPTest)
			Return False
		EndIf
	EndIf
	If $iChoix = 3 Then
		If FileExists(GUICtrlRead($InputFichierLocal)) Then
			If MsgBox(4388, "Confirmation", "Le fichier local existe dj." & @CRLF & "Voulez-vous le remplacer ?", 0, $FormFTPTest) = 7 Then Return False
		EndIf
	EndIf
	If ($iChoix = 2) Or ($iChoix = 3) Or ($iChoix = 7) Then
		If GUICtrlRead($InputFichierServeur) = "" Then
			MsgBox(4096, "Erreur", "Le fichier distant doit tre renseign", 0, $FormFTPTest)
			Return False
		EndIf
	EndIf
	If ($iChoix = 4) Or ($iChoix = 5)  Or ($iChoix = 6) Then
		If GUICtrlRead($InputDossierDistant) = "" Then
			MsgBox(4096, "Erreur", "Le dossier distant doit tre renseign", 0, $FormFTPTest)
			Return False
		EndIf
	EndIf
	If $iChoix = 5 Then
		If MsgBox(4388, "Confirmation", "Vous voulez supprimer le dossier distant ?" & @CRLF & "(Le dossier distant doit tre vide pour tre supprimer)", 0, $FormFTPTest) = 7 Then Return False
	EndIf
	If $iChoix = 7 Then
		If MsgBox(4388, "Confirmation", "Vous voulez supprimer le fichier distant ?", 0, $FormFTPTest) = 7 Then Return False
	EndIf
	Return True
EndFunc


Func SynchroMotPasse()
	If GUICtrlRead($ButtonMotPasse) = "Masquer" Then
		GUICtrlSetData($InputMotPasseMasque, GUICtrlRead($InputMotPasseVisible))
	Else
		GUICtrlSetData($InputMotPasseVisible, GUICtrlRead($InputMotPasseMasque))
	EndIf
EndFunc


Func LireFicIni()
	GUICtrlSetData($InputServeur, IniRead($scFicIni, "Ecran", "Serveur", ""))
	GUICtrlSetData($InputUtilisateur, IniRead($scFicIni, "Ecran", "Utilisateur", ""))
	If IniRead($scFicIni, "Ecran", "MotPasse", "") = "" Then
		GUICtrlSetData($InputMotPasseMasque, "")
	Else
		GUICtrlSetData($InputMotPasseMasque, _StringEncrypt(0, IniRead($scFicIni, "Ecran", "MotPasse", ""), $scCryptCle))
	EndIf
	GUICtrlSetData($InputMotPasseVisible, GUICtrlRead($InputMotPasseMasque))
	GUICtrlSetData($InputFichierLocal, IniRead($scFicIni, "Ecran", "FichierLocal", ""))
	GUICtrlSetData($InputFichierServeur, IniRead($scFicIni, "Ecran", "FichierServeur", ""))
	GUICtrlSetData($InputDossierDistant, IniRead($scFicIni, "Ecran", "DossierDistant", ""))
EndFunc


Func EcrireFicIni()
	IniWrite($scFicIni, "Ecran", "Serveur", GUICtrlRead($InputServeur))
	IniWrite($scFicIni, "Ecran", "Utilisateur", GUICtrlRead($InputUtilisateur))
	SynchroMotPasse()
	If GUICtrlRead($InputMotPasseMasque) = "" Then
		IniWrite($scFicIni, "Ecran", "MotPasse", "")
	Else
		IniWrite($scFicIni, "Ecran", "MotPasse", _StringEncrypt(1, GUICtrlRead($InputMotPasseMasque), $scCryptCle))
	EndIf
	IniWrite($scFicIni, "Ecran", "FichierLocal", GUICtrlRead($InputFichierLocal))
	IniWrite($scFicIni, "Ecran", "FichierServeur", GUICtrlRead($InputFichierServeur))
	IniWrite($scFicIni, "Ecran", "DossierDistant", GUICtrlRead($InputDossierDistant))
EndFunc


Func Message($sMessage, $bMessageFin = False, $bTaille = False)
	Local $p, $s, $sTexte = GUICtrlRead($EditTrace)
	If $bTaille Then
		$p = StringInStr($sTexte, $scLibelleTaille, 1, -1)
		If $p > 0 Then $sTexte = StringLeft($sTexte, ($p - 1))
	EndIf
	If $bMessageFin Then
		GUICtrlSetData($EditTrace, $sTexte & $sMessage & @CRLF & _StringRepeat("=", 80) & @CRLF)
	Else
		GUICtrlSetData($EditTrace, $sTexte & $sMessage & @CRLF)
	EndIf
	_WinAPI_RedrawWindow($hEditTrace, 0, 0, $RDW_UPDATENOW)
	_GUICtrlEdit_Scroll($EditTrace, $SB_SCROLLCARET)
EndFunc

Func MessageFin()
	Message(_StringRepeat("=", 80))
EndFunc


Func DossierParDefaut($sValActuel, $sDefaut)
	Local $sElement, $i, $j, $s, $b = False
	If $sValActuel = "" Then Return $sDefaut
	$sElement = StringSplit($sValActuel, "\")
	For $i = $sElement[0] To 1 Step -1
		$s = $sElement[1]
		For $j = 2 To $i
			$s &= "\" & $sElement[$j]
		Next
		If _RepertoireExistant($s) Then
			$b = True
			ExitLoop
		EndIf
	Next
	If $b Then
		Return $s
	Else
		Return $sDefaut
	EndIf
EndFunc


Func _RepertoireExistant($sRepertoire)
	If $sRepertoire = "" Then
		Return False
	EndIf
	If DriveStatus($sRepertoire) = "READY" Then
		Return True
	Else
		Return False
	EndIf
EndFunc
